﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;

namespace WC_BoxChartDataLabelsPosition
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.BarChart;
            ultraChart1.Data.DataSource = GetBarData();
            ultraChart1.Data.DataBind();

            ultraChart1.Axis.X.RangeType = Infragistics.UltraChart.Shared.Styles.AxisRangeType.Custom;
            ultraChart1.Axis.X.RangeMin = 0;
            ultraChart1.Axis.X.RangeMax = 11;
            //usniversal way to control the position of the labels
            ultraChart1.Axis.X.Labels.Layout.Padding = 30;

            var text = new ChartTextAppearance();
            text.ItemFormatString = "<DATA_VALUE:#00>";
            text.Row = -2;
            text.Column = -2;
            text.Visible = true;

            //use this property to position the text entirely inside or outside the bars
            text.HorizontalAlign = StringAlignment.Far;

            ultraChart1.BarChart.ChartText.Add(text);

            //one way to control the chart colors
            Override override1 = new Override();
            override1.Column = 0;
            override1.Row = -2;
            override1.PE = new PaintElement(Color.Blue);
            this.ultraChart1.Override.Add(override1);
            Override override2 = new Override();
            override2.Column = 1;
            override2.Row = -2;
            override2.PE = new PaintElement(Color.Orange);
            this.ultraChart1.Override.Add(override2);
            Override override3 = new Override();
            override3.Column = 2;
            override3.Row = -2;
            override3.PE = new PaintElement(Color.Green);
            this.ultraChart1.Override.Add(override3);
            Override override4 = new Override();
            override4.Column = 3;
            override4.Row = -2;
            override4.PE = new PaintElement(Color.Red);
            this.ultraChart1.Override.Add(override4);
        }

        private DataTable GetBarData()
        {
            DataTable mydata = new DataTable();
            //Define the columns and their names
            mydata.Columns.Add("Series Label", typeof(string));
            mydata.Columns.Add("Series A", typeof(int));
            mydata.Columns.Add("Series B", typeof(int));
            mydata.Columns.Add("Series C", typeof(int));
            mydata.Columns.Add("Series D", typeof(int));
            //Add the rows of data
            mydata.Rows.Add(new Object[] { "Bar A", 1, 4, 10, 4 });
            mydata.Rows.Add(new Object[] { "Bar B", 3, 6, 4, 5 });
            mydata.Rows.Add(new Object[] { "Bar C", 5, 8, 6, 7 });
            mydata.Rows.Add(new Object[] { "Bar D", 7, 10, 7, 7 });
            return mydata;
        }
    }
}
