﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Core.Layers;
using Infragistics.UltraChart.Core.Primitives;

namespace WC_CompositeChartSpacing
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraChart1.ChartType = ChartType.Composite;

            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            AxisItem axisY = new AxisItem();
            axisY.Extent = 20;
            axisY.DataType = AxisDataType.Numeric;
            axisY.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axisY.OrientationType = AxisNumber.Y_Axis;
            axisY.LineColor = Color.Silver;
            area.Axes.Add(axisY);

            AxisItem axisY2 = new AxisItem();
            axisY2.Extent = 20;
            axisY2.DataType = AxisDataType.Numeric;
            axisY2.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axisY2.OrientationType = AxisNumber.Y_Axis;
            axisY2.Visible = false;
            axisY2.LineColor = Color.Silver;
            area.Axes.Add(axisY2);

            AxisItem axisX = new AxisItem();
            axisX.Extent = 20;
            axisX.DataType = AxisDataType.String;
            axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing;
            axisX.Labels.ItemFormatString = "<ITEM_LABEL>";
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.SetLabelAxisType = SetLabelAxisType.GroupBySeries;
            axisX.LineColor = Color.Silver;
            area.Axes.Add(axisX);

            AxisItem axisX1 = new AxisItem();
            axisX1.Extent = 20;
            axisX1.DataType = AxisDataType.String;
            axisX1.Labels.Orientation = TextOrientation.VerticalLeftFacing;
            axisX1.Labels.ItemFormatString = "<ITEM_LABEL>";
            axisX1.Labels.Visible = false;
            axisX1.OrientationType = AxisNumber.X_Axis;
            axisX1.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX1.LineColor = Color.Silver;
            area.Axes.Add(axisX1);

            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.ColumnChart;
            myColumnLayer.SwapRowsAndColumns = true;
            myColumnLayer.ChartArea = area;

            ChartLayerAppearance myLineLayer = new ChartLayerAppearance();
            myLineLayer.ChartType = ChartType.LineChart;
            myLineLayer.ChartArea = area;

            DataTable dt = new DataTable();
            dt.Columns.Add("Month");
            dt.Columns.Add("Cumm Plane");
            dt.Columns.Add("Monthly Achieve");

            dt.Rows.Add("Apr-10", 1.039381, 0.00);
            dt.Rows.Add("May-10", 1.531703, 0.00);
            dt.Rows.Add("Jun-10", 2.166947, 2.50);
            dt.Rows.Add("Jul-10", 2.943036, 4.00);
            dt.Rows.Add("Aug-10", 3.837218, 3.20);
            dt.Rows.Add("Sep-10", 4.802984, 4.10);
            dt.Rows.Add("Oct-10", 5.771378, 4.70);
            dt.Rows.Add("Nov-10", 6.657660, 6.70);
            dt.Rows.Add("Dec-10", 7.372884, 6.70);
            dt.Rows.Add("Jan-11", 7.838389, 8.20);
            dt.Rows.Add("Feb-11", 8.000000, 8.30);
            dt.Rows.Add("Mar-11", 7.838389, 7.90);
            dt.Rows.Add("Apr-11", 7.372884, 6.80);
            dt.Rows.Add("May-11", 6.657660, 5.70);
            dt.Rows.Add("Jun-11", 5.771378, 5.40);
            dt.Rows.Add("Jul-11", 4.802984, 5.70);
            dt.Rows.Add("Aug-11", 3.837218, 5.20);
            dt.Rows.Add("Sep-11", 2.943036, 5.10);
            dt.Rows.Add("Nov-11", 2.166947, 4.60);
            dt.Rows.Add("Dec-11", 1.531703, 3.20);

            NumericSeries series2 = new NumericSeries();
            series2.DataBind(dt, "Monthly Achieve", "Month");
            series2.PEs.Add(new PaintElement(Color.DimGray));
            myColumnLayer.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series2);

            NumericSeries series3 = new NumericSeries();
            series3.DataBind(dt, "Cumm Plane", "Month");
            series3.PEs.Add(new PaintElement(Color.Red));
            myLineLayer.Series.Add(series3);
            ultraChart1.CompositeChart.Series.Add(series3);

            for (int i = 1; i < dt.Rows.Count; i++)
            {
                Override colorOverride = new Override();
                colorOverride.Column = -2;
                colorOverride.Row = i;
                colorOverride.PE = new PaintElement(Color.LightSlateGray);
                this.ultraChart1.Override.Add(colorOverride);
            }

            ColumnChartAppearance appearance = new ColumnChartAppearance();
            appearance.SeriesSpacing = 0;
           
            myColumnLayer.ChartTypeAppearance = appearance;

            myLineLayer.AxisX = axisX1;
            myLineLayer.AxisY = axisY2;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myLineLayer);

            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axisY;
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            foreach (Primitive p in e.SceneGraph)
            {
                Box bar = p as Box;
                if (bar != null)
                {
                    bar.PE.Stroke = Color.LightGray;
                }
            }
        }

    }
}
